interface AlreadyExistsErrorDetails {
  property: string;
  value: string;
}

export function extractDetailsQueryError(
  detail: string,
): AlreadyExistsErrorDetails {
  const matches: string[] = detail
    .match(/\(.*?\)/g)
    .map((x) => x.replace(/[()]/g, ''));
  return {
    property: matches[0],
    value: matches[1],
  };
}

export class AlreadyExistsError extends Error {
  constructor(entity: string, property: string, value: string) {
    super(`${entity} with ${property} ${value} already exists`);
    if (Error.captureStackTrace) {
      Error.captureStackTrace(this, AlreadyExistsError);
    }
  }

  get name() {
    return this.constructor.name;
  }
}
