export class NotFoundError extends Error {
  constructor(entity: string, property: string, value: string) {
    super(`${entity} with ${property} ${value} not found`);
    if (Error.captureStackTrace) {
      Error.captureStackTrace(this, NotFoundError);
    }
  }

  get name() {
    return this.constructor.name;
  }
}
